var pArea, bang, timerVar, lblMines;
var game = {
    tileWidth: 68,
    first: true,
    mines: 10,
    rows: 9,
    columns: 9,
    found: 10,
    seconds: 0,
    revealed: 0,
    sound: true,
     tiles: []
};
$.when( $.ready ).then(function() {
    pArea = $("#dvPlayArea");
    lblMines = $("#lblMCount");
    lblMines.html(game.found);
    // testing
    lblMines.click(showWin);
    $("#iSet").click(showSettings);
    $("#dvBtn").hide();
    $("#btnStart").click(reStart);
    $("#iClose").click(function() {$('#dvSetOuter').hide();});
    $("#cbSound").change(function() {game.sound = $("#cbSound").prop("checked");});
    bang = new Audio("audio/Explosion+3.wav");
    buildTiles();
  });
function buildTiles() {
    for(var row = 0; row < game.rows; row++){
        game.tiles.push([]);
        for(let col = 0; col < game.columns; col++) {
            let nDiv = $("<div>").prop('id', 'dv' + col + row)
            .mousedown(function(e){tileClick(e, this);})
            .addClass("tileDiv")
            .css({left: col * game.tileWidth + 'px', top: row * game.tileWidth + 'px'});
            let btile = $("<img>")
                .attr('src', "images/TileRev68.png")
                .addClass("tileImage tileBottom");
            let ttile = $("<img>")
                .attr('src', "images/Tile68.png")
                .prop('id', 'it'+ col + row)
                .addClass("tileImage tileTop");
            nDiv.append(btile).append(ttile);
            pArea.append(nDiv);
            let obj = {mine: false, count: 0, state: 0};
            game.tiles[row].push(obj);
        }
    }
    pArea.css({width: game.tileWidth * game.columns +'px', height: game.tileWidth * game.rows + 'px'}).addClass("pArea");
}
function tileClick(e, what) {
    let leftClick = e.which == 1 ? true : false;
    let col = parseInt(what.id.substr(2,1));
    let row = parseInt(what.id.substr(3));
    if(game.first){
        if(!leftClick){ return;} // false start
        setTiles(col, row); // add mines and clues
        timerVar = setInterval(timerTick, 1000);
        game.first = false;
    }
    if(leftClick){
        if(game.tiles[row][col].mine){
            clearInterval(timerVar);
            blowUp(row, col);
            $("#dvBtn").show();
        } else {
            reveal(row, col);
         }
    } else {
        switch(game.tiles[row][col].state) {
            case 0:
                // hide mine (if it is) and show flag. set state 2
                hideMine(col, row);
                 break;
            case 2:
                // hide flag and show question mark set state 3
                flagToQ(col,row)
                 break;
            case 3:
                // hide question mark and reset top tile ? mine image set state to 0
                resetTile(col, row);
                break;
        }
    }
    if(game.revealed === game.rows * game.columns){
        // game over the player won
        gameWon();
    }
}
function hideMine(col, row) {
    if($("#ft" + col + "" + row).length === 0) {
        let ft = $("<img>").attr('src', "images/flag.png")
                    .prop('id', 'ft' + col + row)
                    .addClass("tileImage tileMid");
        let qt = $("<img>").attr('src', "images/Tile68-q.png")
                    .prop('id', 'qt' + col + row)
                    .addClass("tileImage tileMid");
        let dvt = $("#dv" + col + "" + row);
        dvt.append(ft).append(qt.hide());
    }
    $("#mt" + col + row + ", #nt" + col + row).hide();
    $("#ft" + col + row).show();
    $("#it" + col + row).slideUp();
    game.tiles[row][col].state = 2;
    if(game.tiles[row][col].mine){
        game.revealed++;
    }
    game.found--;
    lblMines.html(game.found);
}
function flagToQ(col, row) {
    $("#qt" + col + row).show();
    $("#ft" + col + row).hide();
    game.tiles[row][col].state = 3;
    if(game.tiles[row][col].mine){
        game.revealed--;
    }
    game.found++;
    lblMines.html(game.found);
}
function resetTile(col, row){
    $("#it" + col + row).slideDown("fast", function() {
        $("#qt" + col + row).hide();
        $("#mt" + col + row + ", #nt" + col + row).show();
    });
    game.tiles[row][col].state = 0;
}
function reveal(row, col) {
    if(row < 0 || col < 0 || row >= game.rows || col >= game.columns){
        return;
    }
    if(game.tiles[row][col].state === 0 && game.tiles[row][col].mine === false){
        game.tiles[row][col].state = 1;
        $("#it" + col + row).slideUp();
        game.revealed++;
        if(game.tiles[row][col].count === 0){
            for(let r = row-1; r <= row+1; r++){
                for(let c = col-1; c <= col+1; c++){
                    reveal(r, c); // recursive call
                }
            }
        }
    }
}
function setTiles(notCol, notRow) {
    let setMines = game.mines;
    let tileCount = game.columns * game.rows;
    while (setMines > 0){
        let here = Math.floor(Math.random() * tileCount);
        let col = here % game.columns;
        let row = Math.floor(here / game.rows);
        if(game.tiles[row][col].mine === false){
            if(row !== notRow && col !== notCol){
                game.tiles[row][col].mine = true;
                let iTile = $("<img>").attr('src', "images/Tile68-m.png")
                     .prop('id', 'mt'+ col + row)
                     .addClass("tileImage tileMid");
                $("#dv" + col + row). append(iTile);
                setMines--;
            }
        }
    }
    setCounts();
}
function setCounts() {
    for(let row = 0; row < game.rows; row++){
        for(let col = 0; col < game.columns; col++){
            if(game.tiles[row][col].mine == false){
                // count number of adjacent mines
                game.tiles[row][col].count = getCount(row, col);
                if(game.tiles[row][col].count > 0){
                    let pth = "images/Tile68-" + game.tiles[row][col].count + ".png";
                    let iTile = $("<img>").attr('src', pth)
                                .addClass("tileImage tileMid")
                                .prop('id', 'nt' + col + row);
                    $("#dv" + col + row).append(iTile);
                }
            }
        }
    }
}
function getCount(row, col){
    let count = 0;
    for(let r = row -1; r <= row+1; r++){
        for(let c = col-1; c <= col + 1; c++){
            if ((r >= 0) && (c >= 0) && (r < game.rows) && (c < game.columns)){
                if(game.tiles[r][c].mine) {
                    count++;
                }
            }
        }
    }
    return count;
}
function blowUp(row, col){
    // slide the tile, blow up, blow the other mines, show wrecks
    let bangs = [];
    let adj = game.tileWidth / 2;
    let mine = $("#dv" + col + row);
    let lpos = parseInt(mine.css("left")) + adj;
    let tpos = parseInt(mine.css("top")) + adj;
    let img = $("<img>").attr('src', 'images/bang.png').addClass("explosion").hide();
    bangs.push(img.clone().css({left: lpos + 'px', top: tpos + 'px'}));
    pArea.append(bangs[0]);
    setMoreBangs(col, row, adj, bangs, img);
    $("#it" + col + row).hide();
    animateBangs(bangs);
    revealAllTiles();
 }
function setMoreBangs(col, row, adj, bangs, img){
    for(let r = 0; r < game.rows; r++) {
        for (let c = 0; c < game.columns; c++) {
            if(c !== col && r !== row){
                if(game.tiles[r][c].mine){
                    mine = $("#dv" + c + "" + r);
                    let lpos = parseInt(mine.css("left")) + adj;
                    let tpos = parseInt(mine.css("top")) + adj;
                    bangs.push(img.clone().css({left: lpos + 'px', top: tpos + 'px'}));   
                } 
            }
        }
    }
}
function animateBangs(bangs){
    if(game.sound){
        bang.play();
    }
    bangs[0].show().delay(100).animate({
        width: "+=119",
        height: "+=119",
        top: "-=59",
        left: "-=59"
    }, 800).fadeOut(400, function(){
        if(game.sound){
            bang.currentTime = 0;
            bang.play();    
        }
     });
    for(let b = 1; b < bangs.length; b++){
        pArea.append(bangs[b]);
        bangs[b].delay(800).show().animate({
            width: "+=119",
            height: "+=119",
            top: "-=59",
            left: "-=59"              
        }, 700).fadeOut(400);
    }
}
function revealAllTiles(){
    for(let r = 0; r < game.rows; r++) {
        for (let c = 0; c < game.columns; c++) {
            let cr = '' + c + r;
            if(game.tiles[r][c].state === 0){
                $("#it" + cr).hide(); // reveal all tiles
            }
            if(game.tiles[r][c].mine){
                let ss;
                $("#qt" + cr + ", #ft" + cr).hide();
                $("#mt" + cr).show();
                if(game.tiles[r][c].state === 2){
                    ss = $("<img>").attr('src', "images/Tile68-sf.png");
                } else {
                    ss = $("<img>").attr('src', "images/Tile68-s.png");
                }
                ss.addClass("tileImage tileMid");
                $('#dv' + cr).append(ss.hide());
                ss.delay(600).fadeIn("slow");
                $("#mt" + cr).fadeOut("slow");
            }
        }
    }
}
function showSettings() {
    let offset = pArea.offset();
    let dvs = $("#dvSetOuter");
    let wd = parseInt(pArea.css("width")) - parseInt(dvs.css("width"));
    dvs.css({left: (offset.left + wd/2) + 'px', top: (offset.top + 100) + 'px'}).show();
}
function reStart() {
    $("#dvBtn").hide();
    $(".tileTop").slideDown(); // slide all top tiles down again
    $(".tileMid").remove(); // removes all images with this class
    game.revealed = 0;
    game.first = true;
    game.found = game.mines;
    game.seconds = -1; // as timerTick adds a second as well as showing time
    timerTick();
    lblMines.html(game.found);
    game.tiles = [];
    for(let row = 0; row < game.rows; row++){
        game.tiles.push([]);
        for (let col = 0; col < game.columns; col++){
            game.tiles[row].push({mine: false, count: 0, state: 0});
        }
    }
}
function timerTick(){
    game.seconds++;
   let tstr = padToTwo(Math.floor(game.seconds / 3600)) + ":" + padToTwo(Math.floor(game.seconds/60)%60) + ":" + padToTwo(game.seconds % 60);
   $("#dvTimer").html(tstr);
}
function padToTwo (num) { 
    return num > 9 ? "" + num : "0" + num; 
}
function gameWon() {
    clearInterval(timerVar);
    showWin();
    $("#dvBtn").show();
}
function showWin() {
    let dv = $("<div>").html("Winner").css({color: 'red', 'font-size': '64px', 'position': 'relative', 'z-index': 100});
    let ap = new Audio("audio/applause4.mp3");
    pArea.append(dv);
    //dv.css({'margin-left': 'auto', 'margin-right': 'auto'});
    ap.play();
    dv.animate({
        'font-size': "+=64",
        top: "+=64",
        left: "+=100"
    }, 1500).fadeOut('slow', function(){dv.remove();});
 }